//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3C43421101F8.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3C43421101F8.cm

//## begin module%3C43421101F8.cp preserve=no
//## end module%3C43421101F8.cp

//## Module: Weight%3C43421101F8; Package specification
//## Subsystem: XSModel::GlobalContainer%3E4293160205
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/GlobalContainer/Weight.h

#ifndef WEIGHT_H
#define WEIGHT_H 1

//## begin module%3C43421101F8.additionalIncludes preserve=yes
#include "xsTypes.h"
//## end module%3C43421101F8.additionalIncludes

//## begin module%3C43421101F8.includes preserve=yes
//## end module%3C43421101F8.includes

// xsTypes
#include <main/xsTypes.h>
// Error
#include <XSUtil/Error/Error.h>

class SpectralData;
class Model;

//## begin module%3C43421101F8.declarations preserve=no
//## end module%3C43421101F8.declarations

//## begin module%3C43421101F8.additionalDeclarations preserve=yes
//## end module%3C43421101F8.additionalDeclarations


//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    //## begin XSContainer%3E42929A0210.initialDeclarations preserve=yes
    //## end XSContainer%3E42929A0210.initialDeclarations

    //## Class: Weight%3C43401002C4
    //## Category: XSModel::GlobalContainer%3E42929A0210
    //## Subsystem: XSModel::GlobalContainer%3E4293160205
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    //## Uses: <unnamed>%3C4344CF03AD;SpectralData { -> F}
    //## Uses: <unnamed>%3C4345070052;Model { -> F}
    //## Uses: <unnamed>%3C5997E401D2;ArrayContainer { -> }

    class Weight 
    {
      public:
        //## Class: ArrayInitializationError%3C599EBE0296
        //## Category: XSModel::GlobalContainer%3E42929A0210
        //## Subsystem: XSModel::GlobalContainer%3E4293160205
        //## Persistence: Transient
        //## Cardinality/Multiplicity: n



        class ArrayInitializationError : public RedAlert  //## Inherits: <unnamed>%3C599F4E02B9
        {
          public:
            //## Constructors (specified)
              //## Operation: ArrayInitializationError%3C599F270169
              ArrayInitializationError (size_t num);

          protected:
          private:
          private: //## implementation
        };

        //## Destructor (generated)
          virtual ~Weight() = 0;


        //## Other Operations (specified)
          //## Operation: operator()%3C43402A0105
          virtual void operator () (SpectralData& spectrum, const RealArray& norm) const = 0;

          //## Operation: dataVariance%3C43407E00E2
          virtual void dataVariance (const Model& model, ArrayContainer& variance) const;

          //## Operation: varianceDeriv%3C55A0BC038C
          //	returns an array representing the derivative of the
          //	weighting for the input spectrum number.
          virtual void varianceDeriv (const Model& model, ArrayContainer& dv);

          //## Operation: clone%3C84F9630030
          virtual Weight* clone () const = 0;

        //## Get and Set Operations for Class Attributes (generated)

          //## Attribute: name%437387FC022E
          const string& name () const;

      public:
      protected:
        //## Constructors (specified)
          //## Operation: Weight%437388B2000C
          Weight (const string& name);

      private:
      private: //## implementation
        // Data Members for Class Attributes

          //## begin XSContainer::Weight::name%437387FC022E.attr preserve=no  public: const string {U} 
          const string m_name;
          //## end XSContainer::Weight::name%437387FC022E.attr

    };

    //## Class: StandardWeight%3C4348DB02CA
    //## Category: XSModel::GlobalContainer%3E42929A0210
    //## Subsystem: XSModel::GlobalContainer%3E4293160205
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class StandardWeight : public Weight  //## Inherits: <unnamed>%3C4348F50116
    {
      public:
        //## Constructors (specified)
          //## Operation: StandardWeight%43738AF50179
          StandardWeight ();

        //## Destructor (generated)
          virtual ~StandardWeight();


        //## Other Operations (specified)
          //## Operation: operator()%3C4348FB01F7
          virtual void operator () (SpectralData& spectrum, const RealArray& norm) const;

          //## Operation: dataVariance%3C4348FE01B1
          virtual void dataVariance (const Model& model, ArrayContainer& variance) const;

          //## Operation: clone%3C84F97C01F3
          virtual StandardWeight* clone () const;

      protected:
      private:
      private: //## implementation
    };

    //## Class: ModelWeight%3C4341BA0176
    //## Category: XSModel::GlobalContainer%3E42929A0210
    //## Subsystem: XSModel::GlobalContainer%3E4293160205
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ModelWeight : public Weight  //## Inherits: <unnamed>%3C4341EF0301
    {
      public:
        //## Constructors (specified)
          //## Operation: ModelWeight%43738AE60283
          ModelWeight ();

        //## Destructor (generated)
          virtual ~ModelWeight();


        //## Other Operations (specified)
          //## Operation: dataVariance%3C4348080278
          virtual void dataVariance (const Model& model, ArrayContainer& variance) const;

          //## Operation: varianceDeriv%3C55AD16024E
          //	returns an array representing the derivative of the
          //	weighting for the input spectrum number.
          virtual void varianceDeriv (const Model& model, ArrayContainer& dv);

          //## Operation: operator()%3C5AA92E020C
          void operator () (SpectralData& spectrum, const RealArray& norm) const;

          //## Operation: clone%3C84F99600E3
          virtual ModelWeight* clone () const;

      protected:
      private:
      private: //## implementation
    };

    //## Class: GehrelsWeight%3C4341A80377
    //## Category: XSModel::GlobalContainer%3E42929A0210
    //## Subsystem: XSModel::GlobalContainer%3E4293160205
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class GehrelsWeight : public Weight  //## Inherits: <unnamed>%3C4341EB033F
    {
      public:
        //## Constructors (specified)
          //## Operation: GehrelsWeight%43738AC20230
          GehrelsWeight ();

        //## Destructor (generated)
          virtual ~GehrelsWeight();


        //## Other Operations (specified)
          //## Operation: operator()%3C43440E00F9
          virtual void operator () (SpectralData& spectrum, const RealArray& norm) const;

          //## Operation: dataVariance%3C4348000009
          virtual void dataVariance (const Model& model, ArrayContainer& variance) const;

          //## Operation: clone%3C8506190355
          virtual GehrelsWeight* clone () const;

      protected:
      private:
      private: //## implementation
    };

    //## Class: ChurazovWeight%3C43418E01CE
    //## Category: XSModel::GlobalContainer%3E42929A0210
    //## Subsystem: XSModel::GlobalContainer%3E4293160205
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ChurazovWeight : public Weight  //## Inherits: <unnamed>%3C4341E700C4
    {
      public:
        //## Constructors (specified)
          //## Operation: ChurazovWeight%43738A1401FD
          ChurazovWeight ();

        //## Destructor (generated)
          virtual ~ChurazovWeight();


        //## Other Operations (specified)
          //## Operation: operator()%3C43441D028E
          virtual void operator () (SpectralData& spectrum, const RealArray& norm) const;

          //## Operation: dataVariance%3C4347F401FC
          virtual void dataVariance (const Model& model, ArrayContainer& variance) const;

          //## Operation: clone%3C84F9BC0106
          virtual ChurazovWeight* clone () const;

      protected:
      private:
      private: //## implementation
    };

    // Class XSContainer::Weight::ArrayInitializationError 

    // Class XSContainer::Weight 

    //## Get and Set Operations for Class Attributes (inline)

    inline const string& Weight::name () const
    {
      //## begin XSContainer::Weight::name%437387FC022E.get preserve=no
      return m_name;
      //## end XSContainer::Weight::name%437387FC022E.get
    }

    // Class XSContainer::StandardWeight 

    // Class XSContainer::ModelWeight 

    // Class XSContainer::GehrelsWeight 

    // Class XSContainer::ChurazovWeight 

} // namespace XSContainer

//## begin module%3C43421101F8.epilog preserve=yes
//## end module%3C43421101F8.epilog


#endif
